/* This simple routine translate full OpenVMS path DISK:[PATH1...PATHn] or DISK:[PATH1...PATHn]file or [.PATH1...PATHn]file
** 
only for use only with clamav. But anybody can patch this and use for anything 
(c) Alexey Chupahin 17-MAR-2006  under GPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <glob.h>
#include <errno.h>
#include <socket.h>

#ifndef O_BINARY
#define O_BINARY 020
#endif



char *unix2vms(char *src, int dir)
/* 
 * dir=2 end of /.../A  is a directory, it will be [...]A.dir
 * dir=0 end of /.../A is a file */
{
	char *dst;
	int i,j,
	    slash=0,
	    kol_slash=0;
	int strlen_src=strlen(src);
	int dev=0;
	int current_dir=0; /* it is to detect file path like ./dir */

	if (!src) return NULL;
	if (! strchr(src,'/') ) return strdup(src);
	
	if (src[strlen_src-1]=='/')
	{
		src[strlen_src-1]='\0';
		strlen_src--;
	}

	dst = calloc(strlen_src+7, sizeof(char));

	for(i=0;i<strlen_src;i++) 
		if (src[i]=='/') kol_slash++;

	j=0;
	for(i=0;i<strlen_src;i++)
	{
		switch (src[i])
		{
			case '.':
				if ( (src[i+1]=='/') && (i==0) )
					/* begins with ./  */
				{
					current_dir=1;
				}
				else
				{
					dst[j++]='.';
				}
				break;

			case '/': 
				slash++;
				if (current_dir==1)
				{
					break;
				}
		
				if ( (slash==1) && (i==0) ) /* begins with slash */
				{
					dev=1;
					break;
				}
				
				if ( (slash==2) && (slash==kol_slash) && (dev) )
				{
					dst[j++] = ':';	       
					break;
				}					
				
				if ( (slash==2) && (dev) && (slash<kol_slash) ) 
				{
					dst[j++] = ':';	       
					dst[j++] = '[';	       
					break;
				}
				
				if (slash==kol_slash)  /* latest slash */
				{
					if (dir==1)
					{
						dst[j++]='.';
					}
					if ( (dir==2) || (dir==0) )
					{
						dst[j++]=']';
					}
				}
			        else
				{
					dst[j++] = '.';
				}
				
				break;
			default:
				if ( (!dev) && ((i==0) || (current_dir==1)) ) 
				{
					dst[j++] = '[';
					dst[j++] = '.';
					dst[j++] = src[i];
					current_dir=0;
				}
				else
					dst[j++] = src[i];
		}
	}

	if (dir==1)
	{
		dst[j++]=']';
	}

	if (dir==2)
	{
		dst[j++]='.';
		dst[j++]='d';
		dst[j++]='i';
		dst[j++]='r';
	}

	dst[j++]='\0';
	return (dst);
}

#if 0
char *vms2unix(char *src)
{
char *dst;
int  i,j;
int DEV=0; // flag is device present in the src path
int FIL=1;
/* length of unix-style path is less or equal VMS-style path */

if(src==NULL) return NULL;

dst=malloc(strlen(src));

if ( (!strchr(src,':')) && (!strchr(src,'[')) )  j=0;  /* if there is no "disk:[ "  only simple file name */
  else j=1;

for (i=0; i<strlen(src); i++)
{
 switch (src[i])
 {
   case ':' :
	if (i==0) 
	{ 
		return NULL; 
	}
	DEV=1;
	dst[j++]='/';
        break;
   case '[' : 
   	FIL=0;
	if ( (!DEV) && (src[i+1]!='.') ) 
	{ 
		return NULL; 
	} /* incorrect path like ddd[PATH1...PATHn] */
	if ( DEV && (src[i+1]!='.') ) 
		{ 
			dst[0]='/'; 
			dst[j++]='/'; 
			break; 
		}
	if ( (!DEV) && (src[i+1] == '.') && (i==0) ) 
	{ 
		dst[0]='.'; 
		dst[1]='/'; 
		j=2; 
		break;
	}	
	else 	
	{ 	
		return NULL; 
	} /* incorrect path like dddd[PATH1...PATHn] */

	break;
    case '.' : 
	if ( (i>0) && (!FIL) ) 
	{    
		if (src[i-1] != '[') 
		{ 
			dst[j++]='/'; 
		}    
	}
	if (FIL) 
	{ 
		dst[j++] = src[i]; 
	} 
	break;
    case ']' :  
	dst[j++]='/'; 
	FIL=1;
        break;
    default : 
	dst[j++] = src[i];
  }	// switch
 } // for	      

dst[j]='\0';
return (dst);
}
#else

char *vms2unix(char *name)
{
	char *c;
/*	if ( (c=strchr(name,';'))!=NULL )
	{
		*c='\0';
	}
*/	return decc$translate_vms(name);
}

#endif


char * vms_deldots( char *name )
{
  char *i, *name_dup=strdup(name);

  for (i=strchr(name_dup, (int)'.');i=strchr(name_dup, (int)'.');) { *i='_'; }
  for (i=strchr(name_dup, (int)'(');i=strchr(name_dup, (int)'.');) { *i='_'; }
  for (i=strchr(name_dup, (int)')');i=strchr(name_dup, (int)'.');) { *i='_'; }
  return name_dup; 
}

int VMS_OPEN ( const char *name, int flags, mode_t mode, ...)
{

//		return open(name,flags,mode,"ctx=stm","rfm=stmlf");
		return open(name,flags,mode,"ctx=bin");
}

int VMS_OPEN_BIN ( const char *name, int flags, mode_t mode, ...)
{

		return open(name,flags,mode,"ctx=stm","rfm=stmlf");
//		return open(name,flags,mode,"ctx=bin");
}


int VMS_GETTIMEOFDAY ( struct timeval *tp, void *tzp)
{

	return gettimeofday ( tp, NULL );
}

int VMS_LSEEK ( int file_desc, off_t offset, int direction)
{
	fsync(file_desc);
	return lseek(file_desc,offset,direction);
}

char *VMS_GETCWD (char *buffer, size_t size)
{
	return getcwd(buffer,size,0);
}


/**********************************/
/* glob in unix-style realisation */
/**********************************/

static struct FAB fblock;       /* File attribute block */
static struct NAM nblock;       /* Name attribute block for rms */
char searchname[MAXLEN];

int initsearch(char *string)
{
        int status;



        fblock = cc$rms_fab;
        nblock = cc$rms_nam;
        fblock.fab$l_dna = default_name;
        fblock.fab$b_dns = strlen(default_name);
        fblock.fab$l_fna = string;
        fblock.fab$b_fns = strlen(string);
        fblock.fab$l_nam = &nblock;
        nblock.nam$l_esa = searchname;
        nblock.nam$b_ess = sizeof(searchname);

        status = sys$parse(&fblock);
        if(status != RMS$_NORMAL)
        {
                if(status == RMS$_DNF)
                printf("Directory not found:%s\n",searchname);
                else
                return (-1);
        }
        searchname[nblock.nam$b_esl] = 0;   /* Terminate the string  */
        /* Now reset for searching, pointing to the parsed name block */
        fblock = cc$rms_fab;
        fblock.fab$l_nam = &nblock;
        return(nblock.nam$b_esl); /* return the length of the string  */
}

int search(char *buff, int maxlen)
{
int status;
nblock.nam$l_rsa = buff;
nblock.nam$b_rss = maxlen;
//nblock.nam$b_rsl = 0;       /* For next time around  */
while( (status = sys$search(&fblock)) != RMS$_NMF)
{
        buff[nblock.nam$b_rsl] = 0;
        if(status == RMS$_NORMAL)
        {
                return(nblock.nam$b_rsl);
        }
        else
        {
                if( status == RMS$_PRV)
                        printf("%s : No privilege for access.\n",buff);
                else if (status == RMS$_FNF)
                        printf("%s : File not found.\n",buff);
                else
                {
                        printf(" Error in f$search for :%s\n", buff);
                        return (0);
                }
        }
}
return (0);
}


int VMS_GLOB(const char *pattern, int flags,
        int errfunc(const char *err_path, int err_errno), /* errfunc is ignored for a while - only for unix compartibility */ 
        glob_t *pglob) 
{

  glob_t *ret;

  unsigned int nb_paths = 0;
  char newfile[MAXLEN];
  int len=0;

        if ((pattern == NULL) || (pglob == NULL)) return(-1);


        ret = pglob;
        memset(ret, 0, sizeof(glob_t));

        if(initsearch(unix2vms(pattern,0)) <= 0){
                return(0);
        }
/*        nb_paths = 20;
        ret->gl_pathv = (char **) malloc(nb_paths * sizeof(char *));
        if (ret->gl_pathv == NULL) {
                return(-1);
        }
*/
	ret->gl_pathv = (char **) malloc(327680);
        if (ret->gl_pathv == NULL) {
                return(-1);
        }

	while(search(newfile,MAXLEN-1)!=0) {
/*
                if (ret->gl_pathc + 2 > nb_paths) {
                        char **tmp = realloc(ret->gl_pathv, nb_paths * 2 * sizeof(char *));
                        if (tmp == NULL)
                                break;
                        ret->gl_pathv = tmp;
                        nb_paths *= 2;
                }
*/
                ret->gl_pathv[ret->gl_pathc] = strdup(newfile);
                if (ret->gl_pathv[ret->gl_pathc] == NULL)
                        break;
                ret->gl_pathc++;
        }
        ret->gl_pathv[ret->gl_pathc] = NULL;

done :
        return (0);
}


void VMS_GLOBFREE(glob_t *pglob) {
        unsigned int i;

        if (pglob == NULL)
                return;

        for (i = 0;i < pglob->gl_pathc;i++) {
                if (pglob->gl_pathv[i] != NULL)
                        free(pglob->gl_pathv[i]);
        }
}


ssize_t VMS_PREAD( int fd, void *buf, size_t n, off_t offset)
{
	FILE *F;
	off_t pos;
	ssize_t i;
	int err;

	if ( (pos = lseek(fd,offset,SEEK_SET))== -1 )
		return -1;
	i   = read(fd,buf,n);
	err = errno;
	lseek(fd,pos,SEEK_SET);
	errno=err;
	return i;
}

int
is_socket(int fd)
{
	int type, len;

	len = sizeof(type);
	if (getsockopt(fd, SOL_SOCKET, SO_TYPE, (void *)&type, &len) == 0)
		return 1;
	if (errno == ENOTSOCK) errno = 0;
	return 0;
}

/*
main(int argc, char **argv)
{
	char *s;
	int i;
	glob_t pglob;

printf("%s\n",vms2unix(argv[1]));
printf("%s\n",unix2vms("/DEV/1",2));
printf("%s\n",unix2vms("/DEV/1/2/3/4",2));
printf("%s\n",unix2vms("DEV/1",2));
printf("%s\n",unix2vms("./DEV/1",2));
printf("%s\n",unix2vms("./DEV/1",0));
printf("%s\n",unix2vms("./DEV/*",0));
printf("%s\n",unix2vms("./DEV/A/A.*",0));

if (glob("*.EXE",GLOB_DOOFFS, NULL, &pglob) )
{
	printf("Error\n");
	exit(0);
}

for (i=0; i<pglob.gl_pathc; i++)
	printf("%s\n",pglob.gl_pathv[i]);
}
*/
